#!/bin/sh

: ${HOSTNAME:=`hostname`}
exec 1>&-
exec >> $HOME/log/monitor.log
exec 2>&1
echo `date` Restarting monitor.

start-thttpd

sum=`cksum $HOME/bin/monitor.sh`

while [ 1 ]; do
    newsum=`cksum $HOME/bin/monitor.sh`
    if [ "$sum" != "$newsum" ]; then
	echo Newer monitor available. 
	exec $HOME/bin/monitor.sh
    fi

    cd $HOME/run
    for i in `ls core.* lsd.core* 2>/dev/null`
    do
	gdb -x $HOME/bin/gdb-bt-commands $HOME/bin/lsd $i > $i.log
        mv $i $HOME/www/
	# thttpd requires world readable files
	chmod 644 $HOME/www/$i
        bzip2 $HOME/www/$i
	mv $i.log $HOME/www/$i.txt
	tail -20 lsd.log lsd-trace.log lsd.stderr.log lsd.stdout.log >> $HOME/www/$i.txt
	mail -s "$HOSTNAME core: $i" sit+plab-core@mit.edu < $HOME/www/$i.txt
    done

    sleep 300;
done
